﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Fatture2010
{
    public partial class FormCustomers : Form
    {
        public DSInvoices MainDataSource;

        private void CheckCustomerInUse()
        {
            Boolean CustomerValid = false;
            Boolean CustomerInUse = false;
            if (dTCustomersBindingSource.Current != null)
            {
                DSInvoices.DTCustomersRow drCustomer = (DSInvoices.DTCustomersRow)((DataRowView)dTCustomersBindingSource.Current).Row;
                if (drCustomer.RowState == DataRowState.Unchanged || 
                    drCustomer.RowState == DataRowState.Added || 
                    drCustomer.RowState == DataRowState.Modified)
                {
                    CustomerValid = true;
                    if (drCustomer.Name != null)
                        CustomerInUse = (dTInvoicesBindingSource.Find("CustomerName", drCustomer.Name) > -1);
                }
            }

            bindingNavigatorDeleteItem.Enabled = CustomerValid && !CustomerInUse;
            textBoxName.ReadOnly = CustomerInUse;
        }

        public FormCustomers()
        {
            InitializeComponent();
        }

        private void FormCustomers_Load(object sender, EventArgs e)
        {
            dTInvoicesBindingSource.DataSource = MainDataSource;
            dTCustomersBindingSource.DataSource = MainDataSource;
            dTCustomersBindingSource.ResetBindings(false);
            CheckCustomerInUse();
        }

        private void bindingNavigatorAddNewItem_Click(object sender, EventArgs e)
        {
            splitContainer.Panel2.Enabled = true;
            textBoxName.Focus();
        }

        private void bindingNavigatorDeleteItem_Click(object sender, EventArgs e)
        {
            splitContainer.Panel2.Enabled = (dTCustomersBindingSource.Current != null);
        }

        private void dataGridViewCustomers_SelectionChanged(object sender, EventArgs e)
        {
            CheckCustomerInUse();
        }

        private void dataGridViewCustomers_RowStateChanged(object sender, DataGridViewRowStateChangedEventArgs e)
        {
            splitContainer.Panel2.Enabled = (dTCustomersBindingSource.Current != null);
        }

        private void textBoxField_Enter(object sender, EventArgs e)
        {
            TextBox txtSender = (TextBox)sender;
            txtSender.BackColor = Color.Azure;

            int CellIdx = 0;
            int.TryParse((string)txtSender.Tag, out CellIdx);
            
            dataGridViewCustomers.CurrentCell = dataGridViewCustomers.CurrentRow.Cells[CellIdx];
        }

        private void textBoxField_Leave(object sender, EventArgs e)
        {
            TextBox txtSender = (TextBox)sender;
            txtSender.BackColor = SystemColors.Window;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (dTCustomersBindingSource.List.Count > MainDataSource.DTCustomers.Rows.Count)
                dTCustomersBindingSource.AddNew();
            else if (dataGridViewCustomers.CurrentRow != null)
                dTCustomersBindingSource.EndEdit();
        }

    }
}
